`timescale 1ns / 1ps

module audio_core(
SYSTEM_CLOCK,
dcm_locked,

ac97_bit_clock,	// Generated by AC'97
ac97_sdata_in,		// Serial data from AC'97

ac97_sdata_out,	// Serial data to AC'97
ac97_synch,			// Defines boundries of AC'97 frames, controls warm reset
audio_reset_b,		// AC'97 codec cold reset
collision_occured,
start_game,
win_game,
game_running,
point

);

input SYSTEM_CLOCK, ac97_bit_clock, ac97_sdata_in, collision_occured, start_game, win_game, point, game_running;
input dcm_locked;
output ac97_sdata_out, ac97_synch, audio_reset_b;

wire [19:0] left_in_data, right_in_data, left_out_data, right_out_data;
wire reset;

assign reset = !dcm_locked;



// Audio module
audio audio0 (SYSTEM_CLOCK, reset, left_in_data, left_out_data, right_in_data, right_out_data, ready,
	      audio_reset_b, ac97_sdata_out, ac97_sdata_in,
         ac97_synch, ac97_bit_clock	  
			);

// Processing module: takes input, produces required sounds, sends output				  
beep beep0 (SYSTEM_CLOCK, left_out_data, collision_occured, start_game, point, win_game, game_running);

endmodule